﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.UltraChart.Shared.Events;
using Infragistics.UltraChart.Core.Primitives;
using System.Drawing.Drawing2D;
using Infragistics.UltraChart.Core.Util;
using Infragistics.UltraChart.Resources.Appearance;

namespace WindowsFormsApplication87
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.ultraChart1.ScatterChart.LineAppearance.Thickness = 10;
            this.ultraChart1.Axis.X.MajorGridLines.Visible = this.ultraChart1.Axis.X.MinorGridLines.Visible = this.ultraChart1.Axis.Y.MajorGridLines.Visible = this.ultraChart1.Axis.Y.MinorGridLines.Visible = this.ultraChart1.Axis.X.Labels.Visible = this.ultraChart1.Axis.Y.Labels.Visible = false;
        }
        public static double Slope(PointF point1, PointF point2)
        {
            return (point2.Y - point1.Y) / (point2.X - point1.X);
        }
        private Polygon PolylineToPolygon(Polyline input)
        {
            double halfThickness = input.PE.StrokeWidth / 2.0;
            double halfPi = Math.PI / 2.0;
            //DataPoint[] newPoints = new DataPoint[input.points.Length * 2 + 1];
            Point[] newPoints = new Point[input.points.Length * 2 + 1];
            double[] slopes = new double[input.points.Length - 1];
            for (int i = 0; i < input.points.Length - 1; i++)
            {
                slopes[i] = Slope(input.points[i].point, input.points[i + 1].point);
            }
            for (int i = 0; i < input.points.Length - 1; i++)
            {
                double segmentAngle = Math.Atan(slopes[i]);
                double perpendicularAngle1 = segmentAngle + halfPi;
                double perpendicularAngle2 = segmentAngle - halfPi;
                
                Point segmentStart1 = Geometry.AngularToCartesian(input.points[i].point, halfThickness, perpendicularAngle1);
                Point segmentStart2 = Geometry.AngularToCartesian(input.points[i].point, halfThickness, perpendicularAngle2);

                Point segmentEnd1 = Geometry.AngularToCartesian(input.points[i + 1].point, halfThickness, perpendicularAngle1);
                Point segmentEnd2 = Geometry.AngularToCartesian(input.points[i + 1].point, halfThickness, perpendicularAngle2);

                newPoints[i] = segmentStart1;
                newPoints[i + 1] = segmentStart2;
                newPoints[newPoints.Length - i - 2] = segmentEnd1;
                newPoints[newPoints.Length - i - 3] = segmentEnd2;
            }
            newPoints[newPoints.Length - 1] = newPoints[0];
            return new Polygon(newPoints);
        }
        private void ultraChart1_FillSceneGraph(object sender, FillSceneGraphEventArgs e)
        {
            PrimitiveCollection primitivesToAdd = new PrimitiveCollection();
            foreach (Primitive currentPrimitive in e.SceneGraph)
            {
                Polyline currentPolyline = currentPrimitive as Polyline;
                if (currentPolyline != null)
                {
                    Polygon overlayPolygon = this.PolylineToPolygon(currentPolyline);
                    overlayPolygon.Caps |= PCaps.HitTest | PCaps.Tooltip;
                    overlayPolygon.PE.FillOpacity = overlayPolygon.PE.StrokeOpacity = 0;
                    overlayPolygon.Value = overlayPolygon.Row = overlayPolygon.Column = 0;
                    overlayPolygon.Chart = e.ChartCore.ChartType;
                    overlayPolygon.Layer = e.ChartCore.GetChartLayer();
                    primitivesToAdd.Add(overlayPolygon);
                    
                    
                    
                }
                
                
                
            }
            e.SceneGraph.AddRange(primitivesToAdd.ToArray());
        }
    }
}
